<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTextMessageOutbox_V5 ArrayType
 * @subpackage Arrays
 */
class ArrayOfTextMessageOutbox_V5 extends AbstractStructArrayBase
{
    /**
     * The TextMessageOutbox_V5
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TextMessageOutbox_V5[]
     */
    public $TextMessageOutbox_V5;
    /**
     * Constructor method for ArrayOfTextMessageOutbox_V5
     * @uses ArrayOfTextMessageOutbox_V5::setTextMessageOutbox_V5()
     * @param \StructType\TextMessageOutbox_V5[] $textMessageOutbox_V5
     */
    public function __construct(array $textMessageOutbox_V5 = array())
    {
        $this
            ->setTextMessageOutbox_V5($textMessageOutbox_V5);
    }
    /**
     * Get TextMessageOutbox_V5 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TextMessageOutbox_V5[]|null
     */
    public function getTextMessageOutbox_V5()
    {
        return isset($this->TextMessageOutbox_V5) ? $this->TextMessageOutbox_V5 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTextMessageOutbox_V5 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTextMessageOutbox_V5 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTextMessageOutbox_V5ForArrayConstraintsFromSetTextMessageOutbox_V5(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTextMessageOutbox_V5TextMessageOutbox_V5Item) {
            // validation for constraint: itemType
            if (!$arrayOfTextMessageOutbox_V5TextMessageOutbox_V5Item instanceof \StructType\TextMessageOutbox_V5) {
                $invalidValues[] = is_object($arrayOfTextMessageOutbox_V5TextMessageOutbox_V5Item) ? get_class($arrayOfTextMessageOutbox_V5TextMessageOutbox_V5Item) : sprintf('%s(%s)', gettype($arrayOfTextMessageOutbox_V5TextMessageOutbox_V5Item), var_export($arrayOfTextMessageOutbox_V5TextMessageOutbox_V5Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TextMessageOutbox_V5 property can only contain items of type \StructType\TextMessageOutbox_V5, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TextMessageOutbox_V5 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TextMessageOutbox_V5[] $textMessageOutbox_V5
     * @return \ArrayType\ArrayOfTextMessageOutbox_V5
     */
    public function setTextMessageOutbox_V5(array $textMessageOutbox_V5 = array())
    {
        // validation for constraint: array
        if ('' !== ($textMessageOutbox_V5ArrayErrorMessage = self::validateTextMessageOutbox_V5ForArrayConstraintsFromSetTextMessageOutbox_V5($textMessageOutbox_V5))) {
            throw new \InvalidArgumentException($textMessageOutbox_V5ArrayErrorMessage, __LINE__);
        }
        if (is_null($textMessageOutbox_V5) || (is_array($textMessageOutbox_V5) && empty($textMessageOutbox_V5))) {
            unset($this->TextMessageOutbox_V5);
        } else {
            $this->TextMessageOutbox_V5 = $textMessageOutbox_V5;
        }
        return $this;
    }
    /**
     * Add item to TextMessageOutbox_V5 value
     * @throws \InvalidArgumentException
     * @param \StructType\TextMessageOutbox_V5 $item
     * @return \ArrayType\ArrayOfTextMessageOutbox_V5
     */
    public function addToTextMessageOutbox_V5(\StructType\TextMessageOutbox_V5 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TextMessageOutbox_V5) {
            throw new \InvalidArgumentException(sprintf('The TextMessageOutbox_V5 property can only contain items of type \StructType\TextMessageOutbox_V5, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TextMessageOutbox_V5[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TextMessageOutbox_V5|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TextMessageOutbox_V5|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TextMessageOutbox_V5|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TextMessageOutbox_V5|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TextMessageOutbox_V5|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TextMessageOutbox_V5
     */
    public function getAttributeName()
    {
        return 'TextMessageOutbox_V5';
    }
}
